//======================================
//  HUSB-DIO464 Driver I/F DLL Function
//	    file name:hudio464.h
//      OS       :Windows 98SE/2000/XP
//      date     :2002/12/ 2
//      version  :1.0.1.0 			
//	Copyright(C) 2002  Hivertec Inc.  
//  All Rights Reserved.
//======================================

#define NOT_FOUND			0x00000001
#define ALREADY_OPENED		0x00000002
#define NOT_MEMORY			0x00000004
#define INVALID_HANDLE		0x00000008
#define NOT_READY			0x00000010
#define ILLEGAL_PARAM		0x00000100

// -----------------
//		\
// -----------------
// foCX
typedef struct _HUSBDEVINF {
	WORD			BrdID;			// {[hID        ( 0`15 )
	WORD			EPcnt;			// Gh|Cg     (>=2)
	WORD			EPspc[8];		// Gh|Cgdl   (0x81,0x02,0x00,0x00)
	WORD			EPsiz[8];		// Gh|CgoCg(32,32, 0, 0)
	WORD			EPopt[8];		// Gh|CgIvV( \ )
	HANDLE			EPhdl[8];		// Gh|Cgnh(pCvnh)
} HUSBDEVINF, * PHUSBDEVINF;

//------------------------------
//	DLL֐vg^Cv
//------------------------------
#ifdef __cplusplus		// for Microsoft C/C++
extern "C"
{
#endif

// foCX̎擾(FfoCX̌)
__declspec(dllimport) DWORD WINAPI dio464_GetDeviceCount(DWORD*);

// foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
__declspec(dllimport) DWORD WINAPI dio464_GetDeviceInfo(DWORD*, HUSBDEVINF*);

// foCXI[v(FfoCXnh̃AhXAfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI dio464_OpenDevice(DWORD*, HUSBDEVINF*);

// foCXN[Y(FfoCXnh)
__declspec(dllimport) DWORD WINAPI dio464_CloseDevice(DWORD);

// ̓|[gPoCgǍ(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInB(DWORD, WORD, WORD*);

// o̓|[gPoCgǍ(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutB(DWORD, WORD, WORD*);

// o̓|[gPoCg(FfoCXnhA|[gԍAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutB(DWORD, WORD, WORD);

// ̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInW(DWORD, WORD, WORD*);

// o̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutW(DWORD, WORD, WORD*);

// o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutW(DWORD, WORD, WORD);

// ̓|[gSoCgǍ(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInDW(DWORD, DWORD*);

// o̓|[gSoCgǍ(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutDW(DWORD, DWORD*);

// o̓|[gSoCg(FfoCXnhAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutDW(DWORD, DWORD);

// o̓|[gSoCgݒO̓̓|[gSoCgǍ
// (FfoCXnhAo̓f[^Af[^i[)
__declspec(dllimport) DWORD WINAPI dio464_InOutDW(DWORD, DWORD*, DWORD);

// w|[g̃tB^ݒ(FfoCXnhA|[gwATvO)
__declspec(dllimport) DWORD WINAPI dio464_SetFilter(DWORD, WORD, DWORD);

#ifdef __cplusplus
}
#endif

