/*********************************************************/
/*  HUSB-DIO464 Sample Program(Visual C 5.0)			 */	
/*	    file name:sud46400.c							 */
/*      OS       :Windows 98SE/2000/XP					 */
/*      date     :2002/12/ 2							 */
/*      version  :1.0.1.0 								 */
/*	Copyright(C) 2002 Hivertec Inc. All Rights Reserved. */
/*********************************************************/
#include	<windows.h>
#include	"hudio464.h"
#include	"resource.h"

#define IO_MAX			32			// /o̓|[g@{^ ő吔
#define	CNTMAX			16			// foCXő
#define IDM_TMR_INOUT	11021		// /o̓|[g\p^C}[Rg[ID

HBITMAP		hBitGreen, hBitWhite;	// rbg}bv
HWND		hBtnOut  [IO_MAX];		// {^(o̓|[g)
HWND		hStaIn   [IO_MAX];		// X^eBbN(̓|[g)
HWND		hStaOutNo[IO_MAX];		// X^eBbN(o̓|[g rbgNO)
HWND		hStaInNo [IO_MAX];		// X^eBbN(̓|[g rbgNO)
HINSTANCE	hInst;					// CX^Xnh
HUSBDEVINF	hInf[CNTMAX];			// foCX(\)
HUSBDEVINF	gInf;					// foCX(I[v)
DWORD		gBrdNo	= 0;			// foCX(ftHgF1)
DWORD		hDev = (DWORD)-1;		// foCXnh

// ֐`
LRESULT	CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
void	FormLoad(HWND);					// vO[h
void	FormUnload(HWND);				// vOI
void	CmbInfo_Click(HWND, WPARAM);	// foCXIR{{bNX
void	BtnInfo_Click(HWND);			// foCX擾
void	BtnOpen_Click(HWND);			// foCXI[v
void	BtnClose_Click(HWND);			// foCXN[Y
void	BtnOut_Click (HWND, WORD);		// o̓|[g(ON/OFF)
void	TmrInOut(HWND);					// /o̓|[g\p^C}[
void	ErrMsg(HWND, DWORD);			// G[bZ[W\

int APIENTRY WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lqszArgs, int nWinMode)
{
	HWND		hwnd;
	MSG			msg;
	WNDCLASSEX	wc;
	char        szAppName[] = "MainDlg", *dummy;
	
	// x炷߂̃_~[
	dummy = lqszArgs;	

	if(!hPrevInst)	{
		// EBhENX`
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			// EBhE̎(TCYύXĕ`)
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					// EChE֐̃AhX
		wc.cbClsExtra	 =	0;									// ̑̃NX
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						// ̑̃EBhE
		wc.hInstance	 =	hThisInst;							// ̃CX^X̃nh
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	// WACR̃nh
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		// }EXJ[\̃nh
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		// EBhE̔wiF({^̕\ʂ̉e)
		wc.lpszMenuName	 =	NULL;								// Cj[̖O
		wc.lpszClassName =	szAppName;							// EBhENX̖O
		wc.cbSize		 =	sizeof(WNDCLASSEX);					// WNDCLASSEX\̂̃TCYݒ
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		// X[ACR
		
		// EBhENXo^
		if(!RegisterClassEx(&wc)) return 0;
	}

	// ݂̃CX^Xnhۑ
	hInst = hThisInst;

	// EBhENX̓o^ł̂ŁAC̃_CAO{bNX𐶐
 	hwnd = CreateDialog(hInst, "IDD_DIALOG0", 0, (DLGPROC)WndProc);
	if(!hwnd)		return 0;

	// EBhE\
	ShowWindow  (hwnd, nWinMode);
	UpdateWindow(hwnd);

	// bZ[W[v𐶐
	while (GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage(hwnd, &msg)) {
			TranslateMessage(&msg);						// L[{[hp\ɂ
			DispatchMessage (&msg);						// Windowsɖ߂
		}
	}
	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
		// vOJn
		case WM_INITDIALOG:	FormLoad(hwnd);							break;

		// {^NbN̏
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				// foCX擾
				case IDC_BTN_INFO:	BtnInfo_Click(hwnd);			break;
				
				// foCXI & \
				case IDC_CMB_INFO:	CmbInfo_Click(hwnd, wParam);	break;

				// foCXI[v
				case IDC_BTN_OPEN:	BtnOpen_Click(hwnd);			break;

				// foCXN[Y
				case IDC_BTN_CLOS:	BtnClose_Click(hwnd);			break;

				// o̓|[g(ON/OFF){^
				case IDC_BTN_OUT1:	BtnOut_Click(hwnd, 0);			break;
				case IDC_BTN_OUT2:	BtnOut_Click(hwnd, 1);			break;
				case IDC_BTN_OUT3:	BtnOut_Click(hwnd, 2);			break;
				case IDC_BTN_OUT4:	BtnOut_Click(hwnd, 3);			break;
				case IDC_BTN_OUT5:	BtnOut_Click(hwnd, 4);			break;
				case IDC_BTN_OUT6:	BtnOut_Click(hwnd, 5);			break;
				case IDC_BTN_OUT7:	BtnOut_Click(hwnd, 6);			break;
				case IDC_BTN_OUT8:	BtnOut_Click(hwnd, 7);			break;
				case IDC_BTN_OUT9:	BtnOut_Click(hwnd, 8);			break;
				case IDC_BTN_OUT10:	BtnOut_Click(hwnd, 9);			break;
				case IDC_BTN_OUT11:	BtnOut_Click(hwnd, 10);			break;
				case IDC_BTN_OUT12:	BtnOut_Click(hwnd, 11);			break;
				case IDC_BTN_OUT13:	BtnOut_Click(hwnd, 12);			break;
				case IDC_BTN_OUT14:	BtnOut_Click(hwnd, 13);			break;
				case IDC_BTN_OUT15:	BtnOut_Click(hwnd, 14);			break;
				case IDC_BTN_OUT16:	BtnOut_Click(hwnd, 15);			break;
				case IDC_BTN_OUT17:	BtnOut_Click(hwnd, 16);			break;
				case IDC_BTN_OUT18:	BtnOut_Click(hwnd, 17);			break;
				case IDC_BTN_OUT19:	BtnOut_Click(hwnd, 18);			break;
				case IDC_BTN_OUT20:	BtnOut_Click(hwnd, 19);			break;
				case IDC_BTN_OUT21:	BtnOut_Click(hwnd, 20);			break;
				case IDC_BTN_OUT22:	BtnOut_Click(hwnd, 21);			break;
				case IDC_BTN_OUT23:	BtnOut_Click(hwnd, 22);			break;
				case IDC_BTN_OUT24:	BtnOut_Click(hwnd, 23);			break;
				case IDC_BTN_OUT25:	BtnOut_Click(hwnd, 24);			break;
				case IDC_BTN_OUT26:	BtnOut_Click(hwnd, 25);			break;
				case IDC_BTN_OUT27:	BtnOut_Click(hwnd, 26);			break;
				case IDC_BTN_OUT28:	BtnOut_Click(hwnd, 27);			break;
				case IDC_BTN_OUT29:	BtnOut_Click(hwnd, 28);			break;
				case IDC_BTN_OUT30:	BtnOut_Click(hwnd, 29);			break;
				case IDC_BTN_OUT31:	BtnOut_Click(hwnd, 30);			break;
				case IDC_BTN_OUT32:	BtnOut_Click(hwnd, 31);			break;
			}
																	break;
		// ^C}
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				// /o̓|[g\
				case IDM_TMR_INOUT:	TmrInOut(hwnd);					break;
			}
																	break;
		// EBhE鎞̏
		case WM_CLOSE:		FormUnload(hwnd);						break;

		// vOI
		case WM_DESTROY:	PostQuitMessage(0);						break;

		// LȊÕbZ[WWindows ɏ
		default:	return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}

// tH[[h
void FormLoad(HWND hwnd)
{
	RECT	rectW;
	WORD	wIx;
	int		nX, nY;

	// ʍW擾
	nX = GetSystemMetrics(SM_CXSCREEN);		// ʑŜ̕
	nY = GetSystemMetrics(SM_CYSCREEN);		// ʑŜ̍

	// EBhE̋E`̐@擾B
	GetWindowRect(hwnd, &rectW);
	rectW.right  = rectW.right  - rectW.left;
	rectW.bottom = rectW.bottom - rectW.top;

	// EBhE𒆉Ɉړ(͒菭)
	rectW.top  = (nY - rectW.bottom) / 2 - 15;
	rectW.left = (nX - rectW.right ) / 2;
	MoveWindow(hwnd, rectW.left, rectW.top, rectW.right, rectW.bottom, TRUE);
	
	// {^gp/sƃ{^EX^eBbN\̃Zbg
	EnableWindow(GetDlgItem(hwnd, IDC_CMB_INFO), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), FALSE);

	// \[Xt@Cō쐬/o̓|[g̃{^ƃX^eBbÑnh擾
	for(wIx = 0; wIx < IO_MAX; wIx++)	{
		hBtnOut  [wIx] = GetDlgItem(hwnd, IDC_BTN_OUT1   + wIx);
		hStaOutNo[wIx] = GetDlgItem(hwnd, IDC_STA_OUTNO1 + wIx);

		hStaIn   [wIx] = GetDlgItem(hwnd, IDC_STA_IN1   + wIx);
		hStaInNo [wIx] = GetDlgItem(hwnd, IDC_STA_INNO1 + wIx);
	}

	// rbg}bṽ[h
	hBitGreen = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));
	hBitWhite = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
}

// tH[A[h
void FormUnload(HWND hwnd)
{
	// foCXN[Y
	if(hDev != (DWORD)-1) BtnClose_Click(hwnd);

	// foCXReLXg폜
	DeleteObject(hBitGreen);
	DeleteObject(hBitWhite);

	// C̃_CAO{bNX
	DestroyWindow(hwnd);
}

// foCX擾
void BtnInfo_Click(HWND hwnd)
{
	char	buf[255];
	WORD	wIx;
	DWORD	ret;
	DWORD	cnt;	// foCX

    hDev = (DWORD)-1;
    
    // {[h擾
    ret = dio464_GetDeviceCount(&cnt);
	if(ret) {	
		ErrMsg(hwnd, ret);
		return;
	}

    // {[h 0̎G[
    if(!cnt) {
		MessageBox(hwnd, "HUSB-DIO464{[h܂", "sud46400", MB_OK);
		return;
	}
	
    // {[h17ȏ̎G[
    if(cnt > CNTMAX) {
		MessageBox(hwnd, "HUSB-DIO464{[h17ȏ", "sud46400", MB_OK);
		return;
	}

	// foCX擾
	ret = dio464_GetDeviceInfo(&cnt, &hInf[0]);
	if(ret) {	
		ErrMsg(hwnd, ret);
		return;
	}

	// R{{bNX̓eZbg
	SendMessage(GetDlgItem(hwnd, IDC_CMB_INFO), CB_RESETCONTENT, 0l, 0l);

	// R{{bNXɃeLXgACeǉ
	for(wIx = 0; wIx < cnt; wIx++) {
		wsprintf(buf, "%X", hInf[wIx].BrdID );
		SendMessage(GetDlgItem(hwnd, IDC_CMB_INFO), CB_ADDSTRING, 0L, (LPARAM)buf);
	}

    // foCXI[ṽftHgݒ(foCXԍA1)
	SendMessage(GetDlgItem(hwnd, IDC_CMB_INFO), CB_SETCURSEL, 0l, 0l);
		
	// {^gp/sƃ{^EX^eBbN\̃Zbg
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_INFO), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CMB_INFO), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), FALSE);

	CmbInfo_Click(hwnd, MAKEWPARAM(IDC_CMB_INFO, CBN_SELCHANGE));
}

// foCXI
void CmbInfo_Click(HWND hwnd, WPARAM wParam)
{
	DWORD	dwIx = gBrdNo;
	char	buf[255];

	// R{{bNX̃Xg{bNXNbNꂽȊÓAȂB
	if(HIWORD(wParam) != CBN_SELCHANGE) return;

    // gpfoCXڂۑĂB
	dwIx = SendMessage(GetDlgItem(hwnd, IDC_CMB_INFO), CB_GETCURSEL, 0l, 0l);
	SendMessage(GetDlgItem(hwnd, IDC_CMB_INFO), CB_SETCURSEL, dwIx, 0l);

    // w肳ꂽfoCXAfoCXI[vpfoCẌɃRs[
    gInf = hInf[dwIx];

	// foCX\
	wsprintf(buf,"%s  %X%s  %4d%s %04x %04x%s %4d %4d%s %04x %04x%s %04x %04x",	
			"Board ID:",gInf.BrdID,
			"\nEndPoint:",gInf.EPcnt,
			"\nEP spec :",gInf.EPspc[0],gInf.EPspc[1],
			"\nEP size :",gInf.EPsiz[0],gInf.EPsiz[1],
			"\nEPoption:",gInf.EPopt[0],gInf.EPopt[1],
			"\nEPhandle:",gInf.EPhdl[0],gInf.EPhdl[1]);
	SetDlgItemText(hwnd, IDC_STA_INFO, buf);

	SetFocus(GetDlgItem(hwnd, IDC_CMB_INFO));
}

// foCXI[v
void BtnOpen_Click(HWND hwnd)
{
	WORD	wIx;
	DWORD	ret;
	
	// foCXI[v
	ret = dio464_OpenDevice(&hDev, &gInf);
	if(ret) {	
		ErrMsg(hwnd, ret);
		return;
	}

	// {^gp/sƃ{^EX^eBbN\̃Zbg
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_INFO), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CMB_INFO), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), TRUE);

	for(wIx = 0; wIx < IO_MAX; wIx++) {
		EnableWindow(hBtnOut[wIx], TRUE);
		ShowWindow(hBtnOut  [wIx], SW_SHOW);
		ShowWindow(hStaOutNo[wIx], SW_SHOW);
		ShowWindow(hStaInNo[wIx], SW_SHOW);
	}

	// /o̓|[g\p^C}[Jn(110msec)
	SetTimer(hwnd, IDM_TMR_INOUT, 110, NULL);

	// tH[JXړ
	SetFocus(hwnd);
}

// foCXN[Y
void BtnClose_Click(HWND hwnd)
{
    WORD	wIx;
	DWORD	ret;

	if(hDev != (DWORD)-1) {
		// /o̓|[g\p^C}[I
		KillTimer(hwnd, IDM_TMR_INOUT);

		// /o̓|[g\NA
		for(wIx = 0; wIx < IO_MAX; wIx++) {
			SendDlgItemMessage(hwnd, IDC_STA_IN1  + wIx, STM_SETIMAGE,
							   (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
			SendDlgItemMessage(hwnd, IDC_BTN_OUT1 + wIx, BM_SETIMAGE,
							   (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
		}

		// ׂĂ̏o̓|[gɂOo
		ret = dio464_wOutDW(hDev, 0);
		if(ret) {	
			ErrMsg(hwnd, ret);
			return;
		}

		// foCXN[Y
		ret = dio464_CloseDevice(hDev);
		if(ret) {	
			ErrMsg(hwnd, ret);
			return;
		}

		// foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈)
		hDev = (DWORD)-1;

		// {^gp/sƃ{^EX^eBbN\̃Zbg
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_INFO), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CMB_INFO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), FALSE);

		for(wIx = 0; wIx < IO_MAX; wIx++) {
			EnableWindow(hBtnOut[wIx], FALSE);
			ShowWindow(hBtnOut  [wIx], SW_HIDE);
			ShowWindow(hStaOutNo[wIx], SW_HIDE);
			ShowWindow(hStaInNo [wIx], SW_HIDE);
		}

		// tH[JXړ
		SetFocus(GetDlgItem(hwnd, IDC_CMB_INFO));
	}
}

// o̓|[g
void BtnOut_Click(HWND hwnd, WORD wNo)
{
	DWORD	rdt;
	DWORD	wdt;
	DWORD	ret;

	// o̓|[gǍ
	ret = dio464_rOutDW(hDev, &rdt);
	if(ret) {	
		ErrMsg(hwnd, ret);
		return;
	}

    // o̓|[g̊YrbgON/OFFؑւs
	wdt = 0x01 << wNo;
	wdt = wdt ^ rdt;

	// o̓|[g
	ret = dio464_wOutDW(hDev, wdt);
	if(ret) {	
		ErrMsg(hwnd, ret);
		return;
	}
}

// o̓|[gǍ
void TmrInOut(HWND hwnd)
{
	WORD	nBit;
	DWORD	rdt;
	DWORD	ret;

	// ̓|[gǍ
	ret = dio464_rInDW(hDev, &rdt);
	if(ret) {	
		KillTimer(hwnd, IDM_TMR_INOUT);
		ErrMsg(hwnd, ret);
		return;
	}

	// ̓|[gʕ\
	for(nBit = 0; nBit < 32; nBit++) {
		if(rdt & (0x01 << nBit)) {
			// ̓|[g ON  ; ΐF\
			SendDlgItemMessage(hwnd, IDC_STA_IN1 + nBit, STM_SETIMAGE, 
							   (WPARAM)IMAGE_BITMAP, (LPARAM)hBitGreen);
		} else {
			// ̓|[g OFF ; F\
			SendDlgItemMessage(hwnd, IDC_STA_IN1 + nBit, STM_SETIMAGE, 
							   (WPARAM)IMAGE_BITMAP, (LPARAM)hBitWhite);
		}
	}

	// o̓|[gǍ
	ret = dio464_rOutDW(hDev, &rdt);
	if(ret) {	
		KillTimer(hwnd, IDM_TMR_INOUT);
		ErrMsg(hwnd, ret);
		return;
	}

	// o̓|[gʕ\
	for(nBit = 0; nBit < 32; nBit++) {
		if(rdt & (0x01 << nBit)) {
			// o̓|[g ON  ; ΐF\
			SendDlgItemMessage(hwnd, IDC_BTN_OUT1 + nBit, BM_SETIMAGE,
							   (WPARAM)IMAGE_BITMAP, (LPARAM)hBitGreen);
		} else {
			// o̓|[g OFF ; {^Ƀrbg}bv\tȂB
			SendDlgItemMessage(hwnd, IDC_BTN_OUT1 + nBit, BM_SETIMAGE,
								   (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
		}
	}
}

// G[bZ[W
void ErrMsg(HWND hwnd, DWORD dwRet)
{
	char	buf[256];

	switch(dwRet) {
		case NOT_FOUND:
			wsprintf(buf, "foCX܂\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
		case ALREADY_OPENED:
			wsprintf(buf, "dfoCXI[v\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
		case NOT_MEMORY:
			wsprintf(buf, "foCXi[s\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
		case INVALID_HANDLE:
			wsprintf(buf, "ȃfoCXnh\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
		case NOT_READY:
			wsprintf(buf, "foCX̓o̓|[ggpłȂ\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
		case ILLEGAL_PARAM:
			wsprintf(buf, "p[^͈͊O\n߂l:%#lx", dwRet);
			MessageBox(hwnd, buf, "sud46400", MB_OK);
													break;
	}
}
