Attribute VB_Name = "hudio464"
'=============================================
'  HUSB-DIO464 Driver I/F DLL Function Module
'      file name:hudio464.bas
'      OS       :Windows 98SE/2000/XP/Vista
'      date     :2002/12/ 2
'      version  :1.0.1.0
'  Copyright(C) 2002  Hivertec Inc.
'  All Rights Reserved.
'=============================================

Option Explicit

' ߂l
Public Const NOT_FOUND          As Long = &H1
Public Const ALREADY_OPENED     As Long = &H2
Public Const NOT_MEMORY         As Long = &H4
Public Const INVALID_HANDLE     As Long = &H8
Public Const NOT_READY          As Long = &H10
Public Const ILLEGAL_PARAM      As Long = &H100

' \
Type hdl_mat
    dt(0 To 7)      As Long
End Type
Type spc_mat
    dt(0 To 7)      As Integer
End Type

' foCX
Public Type HUSBDEVINF
    BrdID       As Integer              ' {[hID        ( 0`15 )
    EPcnt       As Integer              ' Gh|Cg     (>=2)
    EPspc       As spc_mat              ' Gh|Cgdl   (&H81,&H02,&H00,&H00)
    EPsiz       As spc_mat              ' Gh|CgoCg(32,32, 0, 0)
    EPopt       As spc_mat              ' Gh|CgIvV( \ )
    EPhdl       As hdl_mat              ' Gh|Cgnh(pCvnh)
End Type

' DLL֐vg^Cv
' foCX̎擾(FfoCX̌̃AhX)
Declare Function dio464_GetDeviceCount Lib "hudio464.dll" (ByRef pDevNum As Long) As Long
        
' foCX̎擾(FfoCX̌̃AhXCfoCX񃊃Xg̐擪AhX)
Declare Function dio464_GetDeviceInfo Lib "hudio464.dll" (ByRef pDevNum As Long, pHusbDevInfo As HUSBDEVINF) As Long
        
' foCX̃I[v(FHUSBfoCXnh̃AhXCfoCX̃AhX)
Declare Function dio464_OpenDevice Lib "hudio464.dll" (ByRef hDevID As Long, pHusbDevInfo As HUSBDEVINF) As Long
        
' foCX̃N[Y(FHUSBfoCXnh)
Declare Function dio464_CloseDevice Lib "hudio464.dll" (ByVal hDevID As Long) As Long
                
' ̓|[goCgǍ(FfoCXnhA|[gԍAf[^i[)
Declare Function dio464_rInB Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByRef wData As Integer) As Long

' o̓|[goCgǍ(FfoCXnhA|[gԍAf[^i[)
Declare Function dio464_rOutB Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByRef wData As Integer) As Long

' o̓|[goCg(FfoCXnhA|[gԍAo̓f[^)
Declare Function dio464_wOutB Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByVal wData As Integer) As Long

' ̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
Declare Function dio464_rInW Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByRef wData As Integer) As Long

' o̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
Declare Function dio464_rOutW Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByRef wData As Integer) As Long

' o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
Declare Function dio464_wOutW Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByVal wData As Integer) As Long

' ̓|[gSoCgǍ(FfoCXnhAf[^i[)
Declare Function dio464_rInDW Lib "hudio464.dll" (ByVal hDevID As Long, ByRef dwData As Long) As Long

' o̓|[gSoCgǍ(FfoCXnhAf[^i[)
Declare Function dio464_rOutDW Lib "hudio464.dll" (ByVal hDevID As Long, ByRef dwData As Long) As Long

' o̓|[gSoCg(FfoCXnhAo̓f[^)
Declare Function dio464_wOutDW Lib "hudio464.dll" (ByVal hDevID As Long, ByVal dwData As Long) As Long

' o̓|[gSoCgƓ̓|[gSoCgǍ(FfoCXnhAo̓f[^)
Declare Function dio464_InOutDW Lib "hudio464.dll" (ByVal hDevID As Long, ByRef dwRdt As Long, ByVal dwWdt As Long) As Long

' tB^[̐ݒ(FfoCXnhA|[gwAtB^[)
Declare Function dio464_SetFilter Lib "hudio464.dll" (ByVal hDevID As Long, ByVal wPort As Integer, ByVal dwTime As Long) As Long

